Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6639)
@@ -2917,5 +3593,328 @@
 # endif
 
-               IF( ln_diatrc ) THEN
+               IF( lk_iomput  .AND.  .NOT.  ln_diatrc  ) THEN
+         !!----------------------------------------------------------------------
+         !! Add in XML diagnostics stuff
+         !!----------------------------------------------------------------------
+         !!
+         !! ** 2D diagnostics
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: diag in ij-jj-jk loop'
+                     CALL flush(numout)
+#   endif
+                  IF ( med_diag%PRN%dgsave ) THEN
+                      fprn2d(ji,jj) = fprn2d(ji,jj) + (fprn  * zphn * fthk) 
+                  ENDIF
+                  IF ( med_diag%MPN%dgsave ) THEN
+                      fdpn2d(ji,jj) = fdpn2d(ji,jj) + (fdpn         * fthk)
+                  ENDIF
+                  IF ( med_diag%PRD%dgsave ) THEN
+                      fprd2d(ji,jj) = fprd2d(ji,jj) + (fprd  * zphd * fthk)
+                  ENDIF
+                  IF( med_diag%MPD%dgsave ) THEN
+                      fdpd2d(ji,jj) = fdpd2d(ji,jj) + (fdpd         * fthk) 
+                  ENDIF
+                !  IF( med_diag%DSED%dgsave ) THEN
+                !      CALL iom_put( "DSED"  , ftot_n )
+                !  ENDIF
+                  IF( med_diag%OPAL%dgsave ) THEN
+                      fprds2d(ji,jj) = fprds2d(ji,jj) + (fprds * zpds * fthk) 
+                  ENDIF
+                  IF( med_diag%OPALDISS%dgsave ) THEN
+                      fsdiss2d(ji,jj) = fsdiss2d(ji,jj) + (fsdiss  * fthk)  
+                  ENDIF
+                  IF( med_diag%GMIPn%dgsave ) THEN
+                      fgmipn2d(ji,jj) = fgmipn2d(ji,jj) + (fgmipn  * fthk) 
+                  ENDIF
+                  IF( med_diag%GMID%dgsave ) THEN
+                      fgmid2d(ji,jj) = fgmid2d(ji,jj) + (fgmid   * fthk) 
+                  ENDIF
+                  IF( med_diag%MZMI%dgsave ) THEN
+                      fdzmi2d(ji,jj) = fdzmi2d(ji,jj) + (fdzmi   * fthk) 
+                  ENDIF
+                  IF( med_diag%GMEPN%dgsave ) THEN
+                      fgmepn2d(ji,jj) = fgmepn2d(ji,jj) + (fgmepn  * fthk)
+                  ENDIF
+                  IF( med_diag%GMEPD%dgsave ) THEN
+                      fgmepd2d(ji,jj) = fgmepd2d(ji,jj) + (fgmepd  * fthk) 
+                  ENDIF
+                  IF( med_diag%GMEZMI%dgsave ) THEN
+                      fgmezmi2d(ji,jj) = fgmezmi2d(ji,jj) + (fgmezmi * fthk) 
+                  ENDIF
+                  IF( med_diag%GMED%dgsave ) THEN
+                      fgmed2d(ji,jj) = fgmed2d(ji,jj) + (fgmed   * fthk) 
+                  ENDIF
+                  IF( med_diag%MZME%dgsave ) THEN
+                      fdzme2d(ji,jj) = fdzme2d(ji,jj) + (fdzme   * fthk) 
+                  ENDIF
+                !  IF( med_diag%DEXP%dgsave ) THEN
+                !      CALL iom_put( "DEXP"  , ftot_n )
+                !  ENDIF
+                  IF( med_diag%DETN%dgsave ) THEN
+                      fslown2d(ji,jj) = fslown2d(ji,jj) + (fslown  * fthk)  
+                  ENDIF
+                  IF( med_diag%MDET%dgsave ) THEN
+                      fdd2d(ji,jj) = fdd2d(ji,jj) + (fdd     * fthk) 
+                  ENDIF
+                  IF( med_diag%AEOLIAN%dgsave ) THEN
+                      ffetop2d(ji,jj) = ffetop2d(ji,jj) + (ffetop  * fthk) 
+                  ENDIF
+                  IF( med_diag%BENTHIC%dgsave ) THEN
+                      ffebot2d(ji,jj) = ffebot2d(ji,jj) + (ffebot  * fthk) 
+                  ENDIF
+                  IF( med_diag%SCAVENGE%dgsave ) THEN
+                      ffescav2d(ji,jj) = ffescav2d(ji,jj) + (ffescav * fthk)  
+                  ENDIF
+                  IF( med_diag%PN_JLIM%dgsave ) THEN
+                      fjln2d(ji,jj) = fjln2d(ji,jj) + (fjln  * zphn * fthk) 
+                  ENDIF
+                  IF( med_diag%PN_NLIM%dgsave ) THEN
+                      fnln2d(ji,jj) = fnln2d(ji,jj) + (fnln  * zphn * fthk) 
+                  ENDIF
+                  IF( med_diag%PN_FELIM%dgsave ) THEN
+                      ffln2d(ji,jj) = ffln2d(ji,jj) + (ffln  * zphn * fthk) 
+                  ENDIF
+                  IF( med_diag%PD_JLIM%dgsave ) THEN
+                      fjld2d(ji,jj) = fjld2d(ji,jj) + (fjld  * zphd * fthk) 
+                  ENDIF
+                  IF( med_diag%PD_NLIM%dgsave ) THEN
+                      fnld2d(ji,jj) = fnld2d(ji,jj) + (fnld  * zphd * fthk) 
+                  ENDIF
+                  IF( med_diag%PD_FELIM%dgsave ) THEN
+                      ffld2d(ji,jj) = ffld2d(ji,jj) + (ffld  * zphd * fthk) 
+                  ENDIF
+                  IF( med_diag%PD_SILIM%dgsave ) THEN
+                      fsld2d2(ji,jj) = fsld2d2(ji,jj) + (fsld2 * zphd * fthk) 
+                  ENDIF
+                  IF( med_diag%PDSILIM2%dgsave ) THEN
+                      fsld2d(ji,jj) = fsld2d(ji,jj) + (fsld  * zphd * fthk)
+                  ENDIF
+                !! 
+                  IF( med_diag%TOTREG_N%dgsave ) THEN
+                      fregen2d(ji,jj) = fregen2d(ji,jj) + fregen
+                  ENDIF
+                  IF( med_diag%TOTRG_SI%dgsave ) THEN
+                      fregensi2d(ji,jj) = fregensi2d(ji,jj) + fregensi
+                  ENDIF
+                !! 
+                  IF( med_diag%FASTN%dgsave ) THEN
+                      ftempn2d(ji,jj) = ftempn2d(ji,jj) + (ftempn  * fthk)
+                  ENDIF
+                  IF( med_diag%FASTSI%dgsave ) THEN
+                      ftempsi2d(ji,jj) = ftempsi2d(ji,jj) + (ftempsi * fthk)
+                  ENDIF
+                  IF( med_diag%FASTFE%dgsave ) THEN
+                      ftempfe2d(ji,jj) =ftempfe2d(ji,jj)  + (ftempfe * fthk)  
+                  ENDIF
+                  IF( med_diag%FASTC%dgsave ) THEN
+                      ftempc2d(ji,jj) = ftempc2d(ji,jj) + (ftempc  * fthk)
+                  ENDIF
+                  IF( med_diag%FASTCA%dgsave ) THEN
+                      ftempca2d(ji,jj) = ftempca2d(ji,jj) + (ftempca * fthk)
+                  ENDIF
+                !! 
+                  IF( med_diag%REMINN%dgsave ) THEN
+                      freminn2d(ji,jj) = freminn2d(ji,jj) + (freminn  * fthk)
+                  ENDIF
+                  IF( med_diag%REMINSI%dgsave ) THEN
+                      freminsi2d(ji,jj) = freminsi2d(ji,jj) + (freminsi * fthk)
+                  ENDIF
+                  IF( med_diag%REMINFE%dgsave ) THEN
+                      freminfe2d(ji,jj)= freminfe2d(ji,jj) + (freminfe * fthk) 
+                  ENDIF
+                  IF( med_diag%REMINC%dgsave ) THEN
+                      freminc2d(ji,jj) = freminc2d(ji,jj) + (freminc  * fthk) 
+                  ENDIF
+                  IF( med_diag%REMINCA%dgsave ) THEN
+                      freminca2d(ji,jj) = freminca2d(ji,jj) + (freminca * fthk) 
+                  ENDIF
+                !!
+                !!
+                !!
+                !!  
+                !! 
+                !!
+                !! 
+                !!
+                !!
+# if defined key_roam            
+                 IF (jk.eq.i0100) THEN
+                     IF( med_diag%RR_0100%dgsave ) THEN
+                         ffastca2d(ji,jj) =   &
+                            ffastca(ji,jj)/MAX(ffastc(ji,jj), rsmall)
+                     ENDIF                     
+                 ELSE IF (jk.eq.i0500) THEN 
+                     IF( med_diag%RR_0500%dgsave ) THEN
+                         ffastca2d(ji,jj) =   &
+                            ffastca(ji,jj)/MAX(ffastc(ji,jj), rsmall)
+                     ENDIF                        
+                 ELSE IF (jk.eq.i1000) THEN
+                     IF( med_diag%RR_1000%dgsave ) THEN
+                         ffastca2d(ji,jj) =   &
+                            ffastca(ji,jj)/MAX(ffastc(ji,jj), rsmall)
+                     ENDIF
+                 ELSE IF (jk.eq.(mbathy(ji,jj)-1)) THEN
+                     IF( med_diag%IBEN_N%dgsave ) THEN
+                         iben_n2d(ji,jj) = f_sbenin_n(ji,jj)  + f_fbenin_n(ji,jj)
+                     ENDIF
+                     IF( med_diag%IBEN_FE%dgsave ) THEN
+                         iben_fe2d(ji,jj) = f_sbenin_fe(ji,jj) + f_fbenin_fe(ji,jj)
+                     ENDIF
+                     IF( med_diag%IBEN_C%dgsave ) THEN
+                         iben_c2d(ji,jj) = f_sbenin_c(ji,jj)  + f_fbenin_c(ji,jj)
+                     ENDIF
+                     IF( med_diag%IBEN_SI%dgsave ) THEN
+                         iben_si2d(ji,jj) = f_fbenin_si(ji,jj)
+                     ENDIF
+                     IF( med_diag%IBEN_CA%dgsave ) THEN
+                         iben_ca2d(ji,jj) = f_fbenin_ca(ji,jj)
+                     ENDIF
+                     IF( med_diag%OBEN_N%dgsave ) THEN
+                         oben_n2d(ji,jj) = f_benout_n(ji,jj)
+                     ENDIF
+                     IF( med_diag%OBEN_FE%dgsave ) THEN
+                         oben_fe2d(ji,jj) = f_benout_fe(ji,jj)
+                     ENDIF
+                     IF( med_diag%OBEN_C%dgsave ) THEN
+                         oben_c2d(ji,jj) = f_benout_c(ji,jj)
+                     ENDIF
+                     IF( med_diag%OBEN_SI%dgsave ) THEN
+                         oben_si2d(ji,jj) = f_benout_si(ji,jj)
+                     ENDIF
+                     IF( med_diag%OBEN_CA%dgsave ) THEN
+                         oben_ca2d(ji,jj) = f_benout_ca(ji,jj)
+                     ENDIF
+                     IF( med_diag%SFR_OCAL%dgsave ) THEN
+                         sfr_ocal2d(ji,jj) = f3_omcal(ji,jj,jk)
+                     ENDIF
+                     IF( med_diag%SFR_OARG%dgsave ) THEN
+                         sfr_oarg2d(ji,jj) =  f3_omarg(ji,jj,jk)
+                     ENDIF
+                     IF( med_diag%LYSO_CA%dgsave ) THEN
+                         lyso_ca2d(ji,jj) = f_benout_lyso_ca(ji,jj)
+                     ENDIF
+                 ENDIF
+                !! !! end bathy-1 diags
+                !!
+                  IF( med_diag%RIV_N%dgsave ) THEN
+                      rivn2d(ji,jj) = rivn2d(ji,jj) +  (f_riv_loc_n * fthk)
+                  ENDIF
+                  IF( med_diag%RIV_SI%dgsave ) THEN
+                      rivsi2d(ji,jj) = rivsi2d(ji,jj) +  (f_riv_loc_si * fthk)
+                  ENDIF
+                  IF( med_diag%RIV_C%dgsave ) THEN
+                      rivc2d(ji,jj) = rivc2d(ji,jj) +  (f_riv_loc_c * fthk)
+                  ENDIF
+                  IF( med_diag%RIV_ALK%dgsave ) THEN
+                      rivalk2d(ji,jj) = rivalk2d(ji,jj) +  (f_riv_loc_alk * fthk)
+                  ENDIF
+                  IF( med_diag%DETC%dgsave ) THEN
+                      fslowc2d(ji,jj) = fslowc2d(ji,jj) + (fslowc  * fthk)   
+                  ENDIF
+                !! 
+                !!              
+                !!
+                  IF( med_diag%PN_LLOSS%dgsave ) THEN
+                      fdpn22d(ji,jj) = fdpn22d(ji,jj) + (fdpn2  * fthk)
+                  ENDIF
+                  IF( med_diag%PD_LLOSS%dgsave ) THEN
+                      fdpd22d(ji,jj) = fdpd22d(ji,jj) + (fdpd2  * fthk)
+                  ENDIF
+                  IF( med_diag%ZI_LLOSS%dgsave ) THEN
+                      fdzmi22d(ji,jj) = fdzmi22d(ji,jj) + (fdzmi2 * fthk)
+                  ENDIF
+                  IF( med_diag%ZE_LLOSS%dgsave ) THEN
+                      fdzme22d(ji,jj) = fdzme22d(ji,jj) + (fdzme2 * fthk)
+                  ENDIF
+                  IF( med_diag%ZI_MES_N%dgsave ) THEN
+                      zimesn2d(ji,jj) = zimesn2d(ji,jj) +  &
+                                      (xphi * (fgmipn + fgmid) * fthk)
+                  ENDIF
+                  IF( med_diag%ZI_MES_D%dgsave ) THEN
+                      zimesd2d(ji,jj) = zimesd2d(ji,jj) + & 
+                                      ((1. - xbetan) * finmi * fthk)
+                  ENDIF
+                  IF( med_diag%ZI_MES_C%dgsave ) THEN
+                      zimesc2d(ji,jj) = zimesc2d(ji,jj) + &
+                             (xphi * ((xthetapn * fgmipn) + fgmidc) * fthk)
+                  ENDIF
+                  IF( med_diag%ZI_MESDC%dgsave ) THEN
+                      zimesdc2d(ji,jj) = zimesdc2d(ji,jj) + &
+                                       ((1. - xbetac) * ficmi * fthk)
+                  ENDIF
+                  IF( med_diag%ZI_EXCR%dgsave ) THEN
+                      ziexcr2d(ji,jj) = ziexcr2d(ji,jj) +  (fmiexcr * fthk)
+                  ENDIF
+                  IF( med_diag%ZI_RESP%dgsave ) THEN
+                      ziresp2d(ji,jj) = ziresp2d(ji,jj) +  (fmiresp * fthk)
+                  ENDIF
+                  IF( med_diag%ZI_GROW%dgsave ) THEN
+                      zigrow2d(ji,jj) = zigrow2d(ji,jj) + (fmigrow * fthk)
+                  ENDIF
+                  IF( med_diag%ZE_MES_N%dgsave ) THEN
+                      zemesn2d(ji,jj) = zemesn2d(ji,jj) + &
+                          (xphi * (fgmepn + fgmepd + fgmezmi + fgmed) * fthk)
+                  ENDIF
+                  IF( med_diag%ZE_MES_D%dgsave ) THEN
+                      zemesd2d(ji,jj) = zemesd2d(ji,jj) + &
+                                      ((1. - xbetan) * finme * fthk)
+                  ENDIF
+                  IF( med_diag%ZE_MES_C%dgsave ) THEN
+                      zemesc2d(ji,jj) = zemesc2d(ji,jj) +                         & 
+                            (xphi * ((xthetapn * fgmepn) + (xthetapd * fgmepd) +  &
+                            (xthetazmi * fgmezmi) + fgmedc) * fthk)
+                  ENDIF
+                  IF( med_diag%ZE_MESDC%dgsave ) THEN
+                      zemesdc2d(ji,jj) = zemesdc2d(ji,jj) +  &
+                                       ((1. - xbetac) * ficme * fthk)
+                  ENDIF
+                  IF( med_diag%ZE_EXCR%dgsave ) THEN
+                      zeexcr2d(ji,jj) = zeexcr2d(ji,jj) + (fmeexcr * fthk)
+                  ENDIF
+                  IF( med_diag%ZE_RESP%dgsave ) THEN
+                      zeresp2d(ji,jj) = zeresp2d(ji,jj) + (fmeresp * fthk)
+                  ENDIF
+                  IF( med_diag%ZE_GROW%dgsave ) THEN
+                      zegrow2d(ji,jj) = zegrow2d(ji,jj) + (fmegrow * fthk)
+                  ENDIF
+                  IF( med_diag%MDETC%dgsave ) THEN
+                      mdetc2d(ji,jj) = mdetc2d(ji,jj) + (fddc * fthk)
+                  ENDIF
+                  IF( med_diag%GMIDC%dgsave ) THEN
+                      gmidc2d(ji,jj) = gmidc2d(ji,jj) + (fgmidc * fthk)
+                  ENDIF
+                  IF( med_diag%GMEDC%dgsave ) THEN
+                      gmedc2d(ji,jj) = gmedc2d(ji,jj) + (fgmedc  * fthk)
+                  ENDIF
+# endif                   
+                !! 
+         !!
+         !!
+         !!
+         !!
+         !! ** 3D diagnostics
+                  IF( med_diag%TPP3%dgsave ) THEN
+                      tpp3d(ji,jj,jk) =  (fprn + fprd) * zphn 
+                      !CALL iom_put( "TPP3"  , tpp3d )
+                  ENDIF
+
+                  IF( med_diag%REMIN3N%dgsave ) THEN
+                      remin3dn(ji,jj,jk) = fregen + (freminn * fthk)  !! remineralisation
+                      !CALL iom_put( "REMIN3N"  , remin3dn )
+                  ENDIF
+                  !! IF( med_diag%PH3%dgsave ) THEN
+                  !!     CALL iom_put( "PH3"  , f3_pH )
+                  !! ENDIF
+                  !! IF( med_diag%OM_CAL3%dgsave ) THEN
+                  !!     CALL iom_put( "OM_CAL3"  , f3_omcal )
+                  !! ENDIF
+         !!
+         !!
+         !! ** Without using iom_use
+               ELSE IF( ln_diatrc ) THEN
+#   if defined key_debug_medusa
+                  IF (lwp) write (numout,*) 'trc_bio_medusa: diag in ij-jj-jk ln_diatrc'
+                  CALL flush(numout)
+#   endif
                   !!----------------------------------------------------------------------
                   !! Prepare 2D diagnostics
@@ -2925,7 +3924,7 @@
                   !!    IF (lwp) write (*,*) '*******!MEDUSA DIAADD!*******',kt
                   !! endif     
-                  trc2d(ji,jj,1)  = trc2d(ji,jj,1)  + ftot_n                   !! nitrogen inventory
-                  trc2d(ji,jj,2)  = trc2d(ji,jj,2)  + ftot_si                  !! silicon  inventory
-                  trc2d(ji,jj,3)  = trc2d(ji,jj,3)  + ftot_fe                  !! iron     inventory
+                  trc2d(ji,jj,1)  =  ftot_n(ji,jj)                             !! nitrogen inventory
+                  trc2d(ji,jj,2)  =  ftot_si(ji,jj)                            !! silicon  inventory
+                  trc2d(ji,jj,3)  =  ftot_fe(ji,jj)                            !! iron     inventory
                   trc2d(ji,jj,4)  = trc2d(ji,jj,4)  + (fprn  * zphn * fthk)    !! non-diatom production
                   trc2d(ji,jj,5)  = trc2d(ji,jj,5)  + (fdpn         * fthk)    !! non-diatom non-grazing losses
@@ -2957,8 +3956,8 @@
                   trc2d(ji,jj,31) = trc2d(ji,jj,31) + (fsld2 * zphd * fthk)    !! diatom     Si limitation term 
                   trc2d(ji,jj,32) = trc2d(ji,jj,32) + (fsld  * zphd * fthk)    !! diatom     Si uptake limitation term
-                  if (jk.eq.i0100) trc2d(ji,jj,33) = fslownflux                !! slow detritus flux at  100 m
-                  if (jk.eq.i0200) trc2d(ji,jj,34) = fslownflux                !! slow detritus flux at  200 m
-                  if (jk.eq.i0500) trc2d(ji,jj,35) = fslownflux                !! slow detritus flux at  500 m
-                  if (jk.eq.i1000) trc2d(ji,jj,36) = fslownflux                !! slow detritus flux at 1000 m
+                  if (jk.eq.i0100) trc2d(ji,jj,33) = fslownflux(ji,jj)         !! slow detritus flux at  100 m
+                  if (jk.eq.i0200) trc2d(ji,jj,34) = fslownflux(ji,jj)         !! slow detritus flux at  200 m
+                  if (jk.eq.i0500) trc2d(ji,jj,35) = fslownflux(ji,jj)         !! slow detritus flux at  500 m
+                  if (jk.eq.i1000) trc2d(ji,jj,36) = fslownflux(ji,jj)         !! slow detritus flux at 1000 m
                   trc2d(ji,jj,37) = trc2d(ji,jj,37) + fregen                   !! non-fast N  full column regeneration
                   trc2d(ji,jj,38) = trc2d(ji,jj,38) + fregensi                 !! non-fast Si full column regeneration
@@ -2994,9 +3993,9 @@
                   trc2d(ji,jj,68) = trc2d(ji,jj,68) + (freminca * fthk)        !! sum of fast-sinking Ca fluxes
                   if (jk.eq.(mbathy(ji,jj)-1)) then
-                     trc2d(ji,jj,69) = fsedn                                   !! N  sedimentation flux                                  
-                     trc2d(ji,jj,70) = fsedsi                                  !! Si sedimentation flux
-                     trc2d(ji,jj,71) = fsedfe                                  !! Fe sedimentation flux
-                     trc2d(ji,jj,72) = fsedc                                   !! C  sedimentation flux
-                     trc2d(ji,jj,73) = fsedca                                  !! Ca sedimentation flux
+                     trc2d(ji,jj,69) = fsedn(ji,jj)                                   !! N  sedimentation flux                                  
+                     trc2d(ji,jj,70) = fsedsi(ji,jj)                                  !! Si sedimentation flux
+                     trc2d(ji,jj,71) = fsedfe(ji,jj)                                  !! Fe sedimentation flux
+                     trc2d(ji,jj,72) = fsedc(ji,jj)                                   !! C  sedimentation flux
+                     trc2d(ji,jj,73) = fsedca(ji,jj)                                  !! Ca sedimentation flux
                   endif
                   if (jk.eq.1)  trc2d(ji,jj,74) = qsr(ji,jj)
@@ -3004,6 +4003,6 @@
                   !! if (jk.eq.1)  trc2d(ji,jj,75) = real(iters)
                   !! diagnostic fields 76 to 80 calculated below
-                  trc2d(ji,jj,81) = trc2d(ji,jj,81) + fprn_ml                  !! mixed layer non-diatom production
-                  trc2d(ji,jj,82) = trc2d(ji,jj,82) + fprd_ml                  !! mixed layer     diatom production
+                  trc2d(ji,jj,81) = trc2d(ji,jj,81) + fprn_ml(ji,jj)           !! mixed layer non-diatom production
+                  trc2d(ji,jj,82) = trc2d(ji,jj,82) + fprd_ml(ji,jj)           !! mixed layer     diatom production
 # if defined key_gulf_finland
                   if (jk.eq.1)  trc2d(ji,jj,83) = real(ibio_switch)            !! Gulf of Finland check
@@ -3012,18 +4011,12 @@
 # endif
                   trc2d(ji,jj,84) = fccd(ji,jj)                                !! last model level above calcite CCD depth
-                  if (jk.eq.1)     trc2d(ji,jj,85) = xFree                     !! surface "free" iron
-                  if (jk.eq.i0200) trc2d(ji,jj,86) = xFree                     !! "free" iron at  100 m
-                  if (jk.eq.i0200) trc2d(ji,jj,87) = xFree                     !! "free" iron at  200 m
-                  if (jk.eq.i0500) trc2d(ji,jj,88) = xFree                     !! "free" iron at  500 m
-                  if (jk.eq.i1000) trc2d(ji,jj,89) = xFree                     !! "free" iron at 1000 m
+                  if (jk.eq.1)     trc2d(ji,jj,85) = xFree(ji,jj)              !! surface "free" iron
+                  if (jk.eq.i0200) trc2d(ji,jj,86) = xFree(ji,jj)              !! "free" iron at  100 m
+                  if (jk.eq.i0200) trc2d(ji,jj,87) = xFree(ji,jj)              !! "free" iron at  200 m
+                  if (jk.eq.i0500) trc2d(ji,jj,88) = xFree(ji,jj)              !! "free" iron at  500 m
+                  if (jk.eq.i1000) trc2d(ji,jj,89) = xFree(ji,jj)              !! "free" iron at 1000 m
                   !! AXY (27/06/12): extract "euphotic depth"
                   if (jk.eq.1)     trc2d(ji,jj,90) = xze(ji,jj)
                   !! 
-                  ftot_pn(ji,jj)  = ftot_pn(ji,jj)  + (zphn * fthk)            !! vertical integral non-diatom phytoplankton
-                  ftot_pd(ji,jj)  = ftot_pd(ji,jj)  + (zphd * fthk)            !! vertical integral diatom phytoplankton
-                  ftot_zmi(ji,jj) = ftot_zmi(ji,jj) + (zzmi * fthk)            !! vertical integral microzooplankton
-                  ftot_zme(ji,jj) = ftot_zme(ji,jj) + (zzme * fthk)            !! vertical integral mesozooplankton
-                  ftot_det(ji,jj) = ftot_det(ji,jj) + (zdet * fthk)            !! vertical integral slow detritus, nitrogen
-                  ftot_dtc(ji,jj) = ftot_dtc(ji,jj) + (zdtc * fthk)            !! vertical integral slow detritus, carbon
 # if defined key_roam
                   !! ROAM provisionally has access to a further 20 2D diagnostics
@@ -3077,15 +4070,15 @@
                   trc2d(ji,jj,140) = trc2d(ji,jj,140) + (f_riv_loc_alk * fthk)
                   trc2d(ji,jj,141) = trc2d(ji,jj,141) + (fslowc  * fthk)       !! slow sinking detritus C production
-                  if (jk.eq.i0100) trc2d(ji,jj,142) = fslowcflux               !! slow detritus flux at  100 m
-                  if (jk.eq.i0200) trc2d(ji,jj,143) = fslowcflux               !! slow detritus flux at  200 m
-                  if (jk.eq.i0500) trc2d(ji,jj,144) = fslowcflux               !! slow detritus flux at  500 m
-                  if (jk.eq.i1000) trc2d(ji,jj,145) = fslowcflux               !! slow detritus flux at 1000 m
-                  trc2d(ji,jj,146)  = trc2d(ji,jj,146)  + ftot_c               !! carbon     inventory
-                  trc2d(ji,jj,147)  = trc2d(ji,jj,147)  + ftot_a               !! alkalinity inventory
-                  trc2d(ji,jj,148)  = trc2d(ji,jj,148)  + ftot_o2              !! oxygen     inventory
+                  if (jk.eq.i0100) trc2d(ji,jj,142) = fslowcflux(ji,jj)        !! slow detritus flux at  100 m
+                  if (jk.eq.i0200) trc2d(ji,jj,143) = fslowcflux(ji,jj)        !! slow detritus flux at  200 m
+                  if (jk.eq.i0500) trc2d(ji,jj,144) = fslowcflux(ji,jj)        !! slow detritus flux at  500 m
+                  if (jk.eq.i1000) trc2d(ji,jj,145) = fslowcflux(ji,jj)        !! slow detritus flux at 1000 m
+                  trc2d(ji,jj,146)  = trc2d(ji,jj,146)  + ftot_c(ji,jj)        !! carbon     inventory
+                  trc2d(ji,jj,147)  = trc2d(ji,jj,147)  + ftot_a(ji,jj)        !! alkalinity inventory
+                  trc2d(ji,jj,148)  = trc2d(ji,jj,148)  + ftot_o2(ji,jj)       !! oxygen     inventory
                   if (jk.eq.(mbathy(ji,jj)-1)) then
                      trc2d(ji,jj,149) = f_benout_lyso_ca(ji,jj)
                   endif
-                  trc2d(ji,jj,150) = trc2d(ji,jj,150) + (fcomm_resp * fthk)    !! community respiration
+                  trc2d(ji,jj,150) = fcomm_resp(ji,jj) * fthk                  !! community respiration
 		  !!
 		  !! AXY (14/02/14): a Valentines Day gift to BASIN - a shedload of new
